Nevar pievienot vairāk kā 25 tēmas Tēmai ir jāsākas ar burtu vai ciparu, tā var saturēt domu zīmes ('-') un var būt līdz 35 simboliem gara.
 
 
 
 
 
 

873 rindas
20 KiB

  1. #!/bin/bash
  2. # TODO: use tput
  3. # If not running interactively, don't do anything
  4. [[ $- != *i* ]] && return
  5. ##########################################
  6. null(){
  7. "$@" >/dev/null 2>&1
  8. }
  9. __try_exec(){
  10. type $1 >/dev/null 2>&1 && "$@"
  11. }
  12. ##########################
  13. # system type
  14. alias ismsys=false
  15. alias iscygwin=false
  16. alias iswindows=false
  17. alias isdarwin=false
  18. alias islinux=false
  19. alias with_coreutils=false # for mac
  20. case `uname` in
  21. (MINGW*) alias ismsys=true ;;
  22. (CYGWIN*) alias iscygwin=true ;;
  23. (Darwin*) alias isdarwin=true ;;
  24. (Linux*) alias islinux=true ;;
  25. esac
  26. null ls --version && alias with_coreutils=true
  27. ( ismsys || iscygwin ) && alias iswindows=true
  28. alias inbash=false
  29. alias inzsh=false
  30. if test -n "$BASH_VERSION"
  31. then
  32. alias inbash=true
  33. elif test -n "$ZSH_VERSION"
  34. then
  35. alias inzsh=true
  36. fi
  37. #################################
  38. __search_string(){
  39. # __search_string str1 str2
  40. # return 0 if str2 is found in str1
  41. expr "$1" : ".*$2.*" >/dev/null
  42. }
  43. if ! __search_string "$PATH" "$HOME/.local/bin"
  44. then
  45. PATH="${PATH}:${HOME}/.local/bin:$HOME/.local/lib/gems/bin"
  46. fi
  47. if ismsys && ! __search_string "$PATH" /c/mingw/bin
  48. then
  49. PATH="$PATH:/c/mingw/bin:/c/mingw/msys/1.0/bin"
  50. fi
  51. # # it is not so good
  52. # # http://archive.linux.or.jp/JF/JFdocs/Program-Library-HOWTO/shared-libraries.html
  53. # # http://superuser.com/questions/324613/installing-a-library-locally-in-home-directory-but-program-doesnt-recognize-it
  54. # without this ENV i cannot run tmux. another way is to use --disable-shared
  55. # when building tmux
  56. if ! __search_string "$LD_LIBRARY_PATH" "$HOME/.local/lib"
  57. then
  58. LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$HOME/.local/lib"
  59. fi
  60. ##################################
  61. export LANG=ja_JP.UTF-8
  62. export LC_MESSAGES=C
  63. export TERMCAP="${TERMCAP}:vb="
  64. ismsys && export HOSTNAME
  65. export ENV=~/.shrc
  66. if false iswindows
  67. then
  68. export PAGER='tr -d \\r | less'
  69. else
  70. export PAGER="less"
  71. fi
  72. export LESS="-iRMX"
  73. _src_hilite_lp_path="`which src-hilite-lesspipe.sh 2>/dev/null`"
  74. if test -n "$_src_hilite_lp_path"
  75. then
  76. export LESSOPEN="| $_src_hilite_lp_path %s"
  77. fi
  78. if null type vim
  79. then
  80. export EDITOR=vim
  81. else
  82. export EDITOR=vi
  83. fi
  84. # export CDPATH=".:~"
  85. export VISUAL="$EDITOR"
  86. export GIT_PAGER="less -F"
  87. export GIT_EDITOR="$EDITOR"
  88. export GIT_MERGE_AUTOEDIT=no
  89. if test -n "$TMUX" && \
  90. echo $TERM | grep screen >/dev/null 2>&1 && \
  91. tmux display -p '#{client_termname}' | grep 256color >/dev/null 2>&1
  92. then
  93. TERM=screen-256color
  94. fi
  95. if test -z "$TMP"
  96. then
  97. if test -n "$TMPDIR"
  98. then
  99. export TMP=$TMPDIR
  100. elif test -n "$TEMP"
  101. then
  102. export TMP="$TEMP"
  103. else
  104. export TMP=/tmp
  105. fi
  106. fi
  107. export TMP="${TMP}/${USER}-tmp"
  108. export TEMP="$TMP"
  109. mkdir -p "$TMP"
  110. ! iswindows && null type stty && {
  111. stty stop undef # unbind C-s to stop displaying output
  112. # stty erase '^h'
  113. }
  114. if iswindows; then
  115. export USER=$USERNAME
  116. fi
  117. _tmux_prefs(){
  118. null type tmux || return 1
  119. tmux set -g mode-keys vi
  120. }
  121. if test -d ~/dbx
  122. then
  123. export CHIT_PATH="$HOME/dbx/.chit"
  124. fi
  125. #######################
  126. iswindows && alias tty="echo cmd.exe"
  127. type fortune >/dev/null 2>&1 && {
  128. fortune
  129. echo
  130. fortune -o
  131. echo
  132. }
  133. uname -a
  134. echo TERM $TERM $(tput colors) colors connected to $(tty), \
  135. running $BASH $BASH_VERSION
  136. if test -n "$TMUX"
  137. then
  138. tmux display -p 'Using tmux #S:#I:#W.#P, client is #{client_termname}' \
  139. 2>/dev/null
  140. echo
  141. fi
  142. ###################################
  143. # some aliases and functions
  144. ( ! with_coreutils && isdarwin ) || test "$TERM" = dumb || \
  145. _coloroption=" --color=auto"
  146. ( ! with_coreutils && isdarwin ) || iswindows || \
  147. _timeoption=" --time-style=long-iso"
  148. ( ! with_coreutils && isdarwin ) || _hideoption=" --hide=[A-Z]*" # do not use
  149. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  150. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  151. _timeformat_num="%Y%m%d%H%M%S"
  152. alias datenum="date +$_timeformat_num"
  153. alias ls="ls -hCF${_coloroption}${_timeoption}"
  154. if ! with_coreutils
  155. then
  156. export LSCOLORS=gxfxcxdxbxegedabagacad
  157. alias ls="ls -G"
  158. fi
  159. # export GREP_OPTIONS=""
  160. alias gr="grep -n --color=always"
  161. iswindows && alias grep="grep -n"
  162. # alias ll="ls -l"
  163. # alias la="ls -A"
  164. # alias lla="ls -Al"
  165. alias less="less -F"
  166. null type emacs && alias em="emacs -nw"
  167. null type vim && alias vi=vim
  168. alias pstree="LANG=C pstree"
  169. alias cp="cp -v"
  170. alias mv="mv -v"
  171. alias rm="rm -v"
  172. alias psaux="ps auxww"
  173. alias q=exit
  174. null type e3em && alias e3=e3em
  175. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  176. alias po=popd
  177. alias pu=pushd
  178. null type sudo && alias sudo="sudo " # use aliases through sudo
  179. null type sudoedit && alias sudoe="sudoedit"
  180. null type halt && alias halt="sudo halt"
  181. null type reboot && alias reboot="sudo reboot"
  182. null type dbus-send && {
  183. alias suspend="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  184. /org/freedesktop/UPower org.freedesktop.UPower.Suspend"
  185. alias hibernate="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  186. /org/freedesktop/UPower org.freedesktop.UPower.Hibernate"
  187. }
  188. alias rand="echo \$RANDOM"
  189. null type file-roller && alias xunp="file-roller -h"
  190. null type paco && alias pc="sudo \paco -D"
  191. alias pycalc="python -i -c 'from math import *' "
  192. null type python3 && alias py3=python3
  193. null type python2 && alias py2=python2
  194. alias _reloadrc="test -f ~/.bashrc && source ~/.bashrc"
  195. # alias mytime="date +%Y%m%d-%H%M%S"
  196. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  197. # type trash >/dev/null 2>&1 && alias rm=trash
  198. null type mpg123 && alias mpg123="mpg123 -C -v --title"
  199. null type xmms2 && alias xm="xmms2"
  200. #export PLAYER="mpg123 -C -v --title"
  201. null type screen && alias screen="screen -e^z^z"
  202. #alias zcd="cd \`zenity --file-selection --directory\`"
  203. null type gtags && alias gtags="gtags --verbose"
  204. null type htags && alias htags="htags --xhtml --symbol --line-number \
  205. --frame --alphabet --verbose"
  206. null type aunpack && alias au=aunpack
  207. null type lv && alias lv="lv|less"
  208. null type rsync && alias rs="rsync --progress --itemize-changes --compress"
  209. isdarwin && alias updatedb="LC_ALL=C updatedb"
  210. # do not use locate installed by macports
  211. isdarwin && test -x /usr/bin/locate && alias locate="/usr/bin/locate"
  212. # pad
  213. alias pad=notepad
  214. null type gedit && alias pad=gedit
  215. null type leafpad && alias pad=leafpad
  216. isdarwin && alias pad="open -e"
  217. null type wicd-curses && alias wic=wicd-curses
  218. null type wicd-cli && alias wil="wicd-cli -y -l | head"
  219. #alias wicn="wicd-cli -y -c -n"
  220. wicn(){
  221. if test $# -eq 0
  222. then
  223. local num
  224. wicd-cli -y -l | head
  225. echo -n "input num: "
  226. read num
  227. test -n "$num" && wicd-cli -y -c -n $num
  228. else
  229. wicd-cli -y -c -n $1
  230. fi
  231. }
  232. for f in /usr/share/vim/vimcurrent/macros/less.sh \
  233. /usr/share/vim/vim73/macros/less.sh \
  234. /usr/share/vim/vim72/macros/less.sh
  235. do
  236. test -f $f && alias vl=$f && break
  237. done
  238. null type yaourt && alias yt=yaourt
  239. null type cower && alias cower="cower --color=auto"
  240. null type pacmatic && {
  241. alias pacman="pacmatic"
  242. export PACMAN="pacmatic"
  243. }
  244. _pacman_update_mirrorlist_with_reflector(){
  245. ml=/etc/pacman.d/mirrorlist
  246. cmd="$(expr "$(grep -m 1 reflector $ml)" : '# With: *\(.*\)')"
  247. if test -z "$cmd"
  248. then
  249. cmd="reflector --verbose -l 5 --sort rate --save $ml"
  250. fi
  251. echo "Running $cmd ..." 1>&2
  252. sudo $cmd
  253. }
  254. null type reflector && test -f /etc/pacman.d/mirrorlist && \
  255. alias reflect_mirrorlist=_pacman_update_mirrorlist_with_reflector
  256. null type apt-get && {
  257. alias aupgrade="sudo apt-get autoremove --yes && \
  258. sudo apt-get update --yes && sudo apt-get upgrade --yes"
  259. alias aptin="apt-get install"
  260. alias aptsearch="apt-cache search"
  261. alias aptshow="apt-cache show"
  262. }
  263. null type port && {
  264. alias port="port -v"
  265. alias pupgrade="sudo port -v selfupdate && \
  266. { sudo port -v upgrade outdated; }"
  267. }
  268. if iscygwin; then
  269. null type windate || \
  270. alias windate="cmd.exe //c 'echo %DATE%-%TIME%'"
  271. # alias cygsu="cygstart /cygwinsetup.exe"
  272. # alias ls="ls -CFG $(iswindows || test "$TERM" = dumb || echo --color=auto)"
  273. fi
  274. g(){
  275. if test $# -eq 0 && null type git-info
  276. then
  277. git info
  278. else
  279. git "$@"
  280. fi
  281. }
  282. if null type _git && inbash
  283. then
  284. # enable programmable completion for g
  285. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  286. || complete -o default -o nospace -F _git g
  287. fi
  288. git svn --help >/dev/null 2>&1 && alias gsvn="git svn"
  289. null type gitmemo && alias m=gitmemo
  290. null type gitmemo && alias m=gitmemo
  291. alias setup.py="sudo python3 setup.py install --record files.txt"
  292. ssh(){
  293. __my_set_screen_title ssh
  294. command ssh "$@"
  295. }
  296. clk(){
  297. local tformat="%Y/%m/%d %H:%M:%S %z"
  298. cal
  299. REPLY=
  300. printf "\\r`date "+${tformat}"`"
  301. read -t 1
  302. while test $? -ne 0
  303. do
  304. printf "\\r`date "+${tformat}"`"
  305. read -t 1
  306. done
  307. }
  308. s(){
  309. # if test $# -eq 0
  310. # then
  311. # echo "No search word given." 1>&2
  312. # return 1
  313. # fi
  314. if git rev-parse --git-dir >/dev/null 2>&1
  315. then
  316. echo ">> Using git-grep" 1>&2
  317. git grep -n "$@"
  318. elif which ag >/dev/null 2>&1
  319. then
  320. echo ">> Using ag" 1>&2
  321. ag --pager="$PAGER" "$@"
  322. elif which ack >/dev/null 2>&1
  323. then
  324. echo ">> Using ack" 1>&2
  325. ack --pager="$PAGER" "$@"
  326. else
  327. echo ">> Using grep" 1>&2
  328. grep -nH --color=always --exclude='.svn/*' --exclude='.git/*' "$@" -r . \
  329. | $PAGER
  330. # echo "No search command found. Use grep." 2>&1
  331. # return 127
  332. fi
  333. }
  334. man(){
  335. env \
  336. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  337. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  338. LESS_TERMCAP_me=$(printf "\e[0m") \
  339. LESS_TERMCAP_se=$(printf "\e[0m") \
  340. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  341. LESS_TERMCAP_ue=$(printf "\e[0m") \
  342. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  343. man "$@"
  344. }
  345. scr(){
  346. test -n "$1" && pf="${1}-"
  347. local _tformat="%Y%m%d-%H%M%S%z"
  348. local _file="${HOME}/${pf}`date +${_tformat}`.script"
  349. SCRIPT=${_file} script ${_file} "$@"
  350. }
  351. netwait(){
  352. while ! ping -c 1 -t 1 example.com
  353. do
  354. true
  355. done
  356. echo network works.
  357. }
  358. cd(){
  359. if test $# -eq 0
  360. then
  361. pushd ~/ >/dev/null
  362. elif test "$1" = -
  363. then
  364. local pwd="$PWD"
  365. command cd "$OLDPWD"
  366. pushd -n "$pwd" >/dev/null # stack last dir
  367. elif ! test -d "$1"
  368. then
  369. echo `basename ${SHELL}`: cd: "$1": No such file or directory 1>&2
  370. return 1
  371. else
  372. pushd "$1" >/dev/null
  373. fi
  374. __dirs_rm_dup "$PWD"
  375. echo "$PWD"
  376. }
  377. __dirs_rm_dup(){
  378. for d in "$@"
  379. do
  380. local next="$(__realpath --strip "$d")"
  381. for l in $(\dirs -v -l | cut -d $'\n' -f 2- | \
  382. \grep -x " *[0-9]\+ \+${next}" | \grep -o "^ *[0-9]\+ " | tac)
  383. do
  384. popd +$l -n >/dev/null
  385. done
  386. done
  387. }
  388. __realpath(){
  389. if type realpath >/dev/null 2>&1
  390. then
  391. command realpath "$@"
  392. else
  393. while ! test -d $1
  394. do
  395. shift
  396. done
  397. local d="$OLDPWD"
  398. command cd "$1"
  399. echo "$PWD"
  400. command cd "$d"
  401. fi
  402. }
  403. dh(){
  404. if test $# -eq 0
  405. then
  406. dirs -v -l
  407. else
  408. local dir="$(dirs -v -l | \grep "^ *$1 \+" | sed "s/^ *[0-9]* *//g")"
  409. cd "$dir"
  410. fi
  411. }
  412. input(){
  413. local foo
  414. stty -echo
  415. read foo
  416. stty echo
  417. echo $foo
  418. }
  419. tmux(){
  420. if test $# -eq 0
  421. then
  422. (cd ~; command tmux start;)
  423. if command tmux has -t main
  424. then
  425. command tmux attach -t main
  426. else
  427. (cd ~; command tmux new -s main;)
  428. fi
  429. else
  430. command tmux "$@"
  431. fi
  432. }
  433. mcrypt-stream(){
  434. test $# -eq 2 || return 1
  435. case $1 in
  436. en)
  437. mcrypt --key $2 | base64 ;;
  438. de)
  439. base64 -d | mcrypt -d --key $2 ;;
  440. esac
  441. }
  442. gpg-stream(){
  443. test $# -eq 2 || return 1
  444. case $1 in
  445. en)
  446. gpg --passphrase $2 -c --batch |base64 ;;
  447. de)
  448. base64 -d|gpg --passphrase $2 -d --batch ;;
  449. esac
  450. }
  451. dgpg(){
  452. if test "$1" = help || test -z "$2"
  453. then
  454. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  455. return
  456. fi
  457. local srcs="$2"
  458. local dsts="$3"
  459. test -z "$dsts" && dsts="${srcs}.out"
  460. local pw
  461. echo -n "dgpg pw: "
  462. read -s pw
  463. echo ""
  464. test -z "$pw" && return 1
  465. for f in *${srcs}
  466. do
  467. local d="$(basename "$f" "${srcs}")${dsts}"
  468. echo -n "Processing $f to $d..."
  469. if test -d "$f"
  470. then
  471. echo "`printf 'failed (%s is directory)' $f`"
  472. elif test -f "$d"
  473. then
  474. echo "`printf 'failed (%s is already exists)' $d`"
  475. elif <"$f" gpg-stream $1 $pw >"$d" 2>/dev/null
  476. then
  477. echo "done"
  478. else
  479. echo "failed"
  480. test -f "$d" && rm "$d"
  481. fi
  482. done
  483. }
  484. alias enst="gpg-stream en"
  485. alias dest="gpg-stream de"
  486. showinfo(){
  487. echo "Japanese letters are 表示可能"
  488. __try_exec diskinfo
  489. ! isdarwin && test -n "${DISPLAY}" && {
  490. __try_exec xrandr | \grep --color=never ^Screen
  491. }
  492. iswindows || __try_exec finger $USER
  493. LANG=C __try_exec id
  494. __try_exec xset q
  495. }
  496. x(){
  497. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  498. #mkdir -p ~/.my/log
  499. # nohup startx >~/.my/log/xorg.log 2>&1 &
  500. # exit
  501. exec startx
  502. else
  503. echo "X cant be started! Another X is already running?" 1>&2
  504. fi
  505. }
  506. bak(){
  507. for file in "$@"
  508. do
  509. cp -v ${file} ${file}.bak
  510. done
  511. }
  512. di(){
  513. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  514. then
  515. local diffcmd=colordiff
  516. else
  517. local diffcmd=diff
  518. fi
  519. ${diffcmd} -u "$@" | ${PAGER}
  520. }
  521. tb(){
  522. local tb="$HOME/.my/tb"
  523. mkdir -p "$tb"
  524. for file in "$@"
  525. do
  526. mv -t "$tb" "$file"
  527. done
  528. }
  529. mkcd(){
  530. if test -z "$1"
  531. then
  532. echo "mkcd: usage: mkcd <dir>"
  533. return 1
  534. elif test -d "$1"
  535. then
  536. echo "Dir \"$1\" already exists."
  537. else
  538. mkdir -p "$1"
  539. echo "Dir \"$1\" created."
  540. fi
  541. cd "$1"
  542. }
  543. mkcdd(){
  544. # make and change date directory
  545. _d=`date +%Y%m%d-%H%M%S`
  546. mkcd "$_d"
  547. }
  548. if test -n "$TMUX" && null type reattach-to-user-namespace
  549. then
  550. alias pbpaste="reattach-to-user-namespace pbpaste"
  551. alias pbcopy="reattach-to-user-namespace pbcopy"
  552. fi
  553. catclip(){
  554. if iswindows
  555. then
  556. cat /dev/clipboard | tr -d \\r
  557. elif isdarwin
  558. then
  559. pbpaste
  560. else
  561. xclip -o -selection "clipboard"
  562. fi
  563. }
  564. setclip(){
  565. if test $# -eq 0
  566. then
  567. exec 3<&0
  568. else
  569. exec 3<<__EOF__
  570. `cat "$@"`
  571. __EOF__
  572. fi
  573. if iswindows
  574. then
  575. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  576. elif isdarwin
  577. then
  578. pbcopy 0<&3
  579. else
  580. 0<&3 xclip -i -f -selection "primary" | \
  581. xclip -i -f -selection "clipboard"
  582. fi
  583. exec 3<&-
  584. }
  585. open_file(){
  586. if iswindows
  587. then
  588. cmd.exe //c start "" "$@"
  589. elif isdarwin
  590. then
  591. touch "$@"
  592. open "$@"
  593. elif islinux
  594. then
  595. touch "$@"
  596. if null type pcmanfm; then
  597. LC_MESSAGES= pcmanfm "$@"
  598. else
  599. LC_MESSAGES= xdg-open "$@" &
  600. fi
  601. else
  602. cat "$@"
  603. fi
  604. }
  605. o(){
  606. if test $# -eq 0
  607. then
  608. open_file .
  609. else
  610. for f in "$@"
  611. do
  612. open_file "$(realpath "$f")"
  613. done
  614. fi
  615. }
  616. convmv-sjis2utf8-test(){
  617. convmv -r -f sjis -t utf8 *
  618. }
  619. convmv-sjis2utf8-notest(){
  620. convmv -r -f sjis -t utf8 * --notest
  621. }
  622. winln(){
  623. # for windose make link (actually junction)
  624. if test $# -eq 0
  625. then
  626. {
  627. echo "usage: winln TARGET LINK_NAME"
  628. echo "Create a link to TARGET with the name LINK_NAME \
  629. (that is, TARGET must already exist)."
  630. echo "About other features run 'junction'."
  631. } 1>&2
  632. return 1
  633. else
  634. junction "$2" "$1"
  635. fi
  636. }
  637. __my_moc_state(){
  638. type mocp >/dev/null 2>&1 || return
  639. test "`mocp -Q %state 2>/dev/null`" = PLAY || return
  640. printf "$1" "`mocp -Q %title 2>/dev/null`"
  641. }
  642. __my_parse_svn_branch() {
  643. local LANG=C
  644. local svn_url=$(svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  645. local svn_repository_root=$(svn info 2>/dev/null | \
  646. sed -ne 's#^Repository Root: ##p')
  647. echo ${svn_url} | sed -e 's#^'"${svn_repository_root}"'##g' | \
  648. awk '{print $1}'
  649. }
  650. __my_svn_ps1(){
  651. if svn status >/dev/null 2>&1
  652. then
  653. local svn_branch=$(__my_parse_svn_branch)
  654. test -n "${svn_branch}" && printf "$1" "{$svn_branch}"
  655. fi
  656. }
  657. __my_battery_status(){
  658. local dir=/sys/class/power_supply/BAT0
  659. if test -d $dir && test -r $dir/status && test -r $dir/charge_full && \
  660. test -r $dir/charge_now
  661. then
  662. local st=$(cat $dir/status)
  663. local full=$(cat $dir/charge_full)
  664. local now=$(cat $dir/charge_now)
  665. local rate=$(expr $now \* 100 / $full)
  666. printf "$1" "${st}:${rate}%"
  667. fi
  668. }
  669. alias bat='__my_battery_status %s\\n'
  670. ip-address(){
  671. type ip >/dev/null 2>&1 || return 1
  672. local ip=$(LANG=C ip addr show scope global | \
  673. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  674. test -n "$ip" && printf $1 $ip
  675. }
  676. test -n "$SCRIPT" && __my_ps1_script_str="${__my_c5}SCR${__my_cdef} "
  677. test -n "$SSH_CONNECTION" && __my_ps1_ssh_str="${__my_c5}SSH${__my_cdef} "
  678. __my_ps1_scale(){
  679. local last=$?
  680. printf "${LINES}x${COLUMNS}"
  681. return $last
  682. }
  683. __my_ps1_tmux(){
  684. local last=$?
  685. null type tmux || return $last
  686. local tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  687. test -n "$TMUX" && echo "[TMUX:$tmuxc]"
  688. return $last
  689. }
  690. __my_ps1_moc(){
  691. local last=$?
  692. __my_moc_state "[MOC:%s]"
  693. return $last
  694. }
  695. for f in /usr/share/git/git-prompt.sh \
  696. /opt/local/share/git-core/git-prompt.sh \
  697. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  698. do
  699. test -r $f && . $f && break
  700. done
  701. GIT_PS1_SHOWDIRTYSTATE=t
  702. GIT_PS1_SHOWUPSTREAM=t
  703. __my_ps1_git(){
  704. local last=$?
  705. null type __git_ps1 || return $last
  706. null __gitdir || return $last
  707. __git_ps1 "[GIT:$(__try_exec git config --get user.name):%s]"
  708. return $last
  709. }
  710. __my_ps1_ipaddr(){
  711. local last=$?
  712. ! iswindows && ip-address [Addr:%s]
  713. return $last
  714. }
  715. __my_ps1_bttry(){
  716. local last=$?
  717. local bst="${TMP}/batterystatus"
  718. if test -z "$DISPLAY" && ! iswindows
  719. then
  720. test -f $bst && local bstr="$(cat $bst)"
  721. test -n "$bstr" && ! echo $bstr | grep 100 >/dev/null 2>&1 && \
  722. echo "[Battery:$bstr]"
  723. __my_battery_status %s >$bst &
  724. fi
  725. return $last
  726. }
  727. __my_ps1_dirs(){
  728. dirs | wc -l
  729. }
  730. __my_ps1_jobs(){
  731. jobs | wc -l
  732. }
  733. if test "$TERM" != dumb
  734. then
  735. __my_c1="\[\e[0;33m\]" # color for PWD
  736. __my_c2="\[\e[0;36m\]" # color for user
  737. __my_c3="\[\e[1;30m\]" # color for OLDPWD
  738. if test "`hostname`" = arch-aspireone; then __my_c4="\[\e[1;34m\]"
  739. elif test "`hostname`" = darwin-mba.local; then __my_c4="\[\e[1;31m\]"
  740. elif test "`hostname`" = newkiwi; then __my_c4="\[\e[1;35m\]"
  741. else __my_c4="\[\e[1;32m\]" # color for ::
  742. fi
  743. __my_c5="\[\e[30;47m\]" # color for SCR
  744. __my_cdef="\[\e[0m\]"
  745. fi
  746. export _LAST_STATUS=$?
  747. __my_export_last_status(){
  748. export _LAST_STATUS=$?
  749. echo $_LAST_STATUS
  750. return $_LAST_STATUS
  751. }
  752. _ps1_bash="\
  753. ${__my_c4}:: ${__my_cdef}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_git)\$(__my_ps1_bttry)\$(__my_ps1_ipaddr)\$(__my_ps1_moc)\n\
  754. ${__my_c4}:: ${__my_cdef}l${SHLVL}n\#j\js\$? $(__my_ps1_scale) \D{%T} ${__my_ps1_script_str}${__my_ps1_ssh_str}\$ "
  755. inbash && PS1=$_ps1_bash
  756. __my_set_screen_title(){
  757. if test -n "$TMUX" && test -z "$INSIDE_EMACS"
  758. then
  759. echo -ne "\033k$1\033\\"
  760. fi
  761. }
  762. __my_set_title(){
  763. case $TERM in
  764. (rxvt*|xterm*|aterm|screen*)
  765. title="$(echo $@)"
  766. test -t 1 &&
  767. test -n "$DISPLAY" &&
  768. test -z "$EMACS" &&
  769. echo -n -e "\033]0;${title}\007"
  770. ;;
  771. esac
  772. }
  773. PROMPT_COMMAND="__my_set_title \${USER}@\${HOSTNAME}\:\${PWD};
  774. __my_set_screen_title \$(basename \"\$PWD\")/"